---
title: Validate AWS CCM config
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > AWS Integration
---

# Validate AWS CCM config{% #validate-aws-ccm-config %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in Preview and may be subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                  |
| ----------------- | ----------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/integration/aws/validate_ccm_config |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/integration/aws/validate_ccm_config |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/integration/aws/validate_ccm_config      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/integration/aws/validate_ccm_config      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/integration/aws/validate_ccm_config  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/integration/aws/validate_ccm_config     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/integration/aws/validate_ccm_config |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/integration/aws/validate_ccm_config |

### Overview

Validate a Cloud Cost Management config for an AWS account using Cost and Usage Report (CUR) 2.0 against Datadog's ingest requirements without persisting it. This endpoint requires any of the following permissions:
`cloud_cost_management_read``cloud_cost_management_write` 


### Request

#### Body Data (required)

Validate a Cloud Cost Management config for an AWS account integration config.

{% tab title="Model" %}

| Parent field | Field                           | Type   | Description                                                                           |
| ------------ | ------------------------------- | ------ | ------------------------------------------------------------------------------------- |
|              | data [*required*]          | object | AWS CCM config validation request data.                                               |
| data         | attributes [*required*]    | object | Attributes for an AWS CCM config validation request.                                  |
| attributes   | account_id [*required*]    | string | Your AWS Account ID without dashes.                                                   |
| attributes   | bucket_name [*required*]   | string | Name of the S3 bucket where the Cost and Usage Report is stored.                      |
| attributes   | bucket_region [*required*] | string | AWS region of the S3 bucket.                                                          |
| attributes   | report_name [*required*]   | string | Name of the Cost and Usage Report.                                                    |
| attributes   | report_prefix                   | string | S3 prefix where the Cost and Usage Report is stored.                                  |
| data         | type [*required*]          | enum   | AWS CCM config validation resource type. Allowed enum values: `ccm_config_validation` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "account_id": "123456789012",
      "bucket_name": "billing",
      "bucket_region": "us-east-1",
      "report_name": "cost-and-usage-report",
      "report_prefix": "reports"
    },
    "type": "ccm_config_validation"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
AWS CCM Config validation result
{% tab title="Model" %}
AWS CCM config validation response body.

| Parent field | Field                         | Type     | Description                                                                                                                                                                                                                                                                                                                                                                         |
| ------------ | ----------------------------- | -------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]        | object   | AWS CCM config validation response data.                                                                                                                                                                                                                                                                                                                                            |
| data         | attributes [*required*]  | object   | Attributes for an AWS CCM config validation response.                                                                                                                                                                                                                                                                                                                               |
| attributes   | account_id [*required*]  | string   | Your AWS Account ID without dashes.                                                                                                                                                                                                                                                                                                                                                 |
| attributes   | issues [*required*]      | [object] | List of validation issues found for the Cost and Usage Report (CUR) 2.0 configuration. Empty when the configuration is valid.                                                                                                                                                                                                                                                       |
| issues       | code [*required*]        | enum     | Identifies the specific reason a Cost and Usage Report (CUR) 2.0 configuration failed validation. Allowed enum values: `ISSUE_CODE_UNSPECIFIED,CREDENTIAL_ERROR,BUCKET_NAME_INVALID_GOVCLOUD,S3_LIST_PERMISSION_MISSING,S3_GET_PERMISSION_MISSING,S3_BUCKET_REGION_MISMATCH,S3_BUCKET_NOT_ACCESSIBLE,EXPORT_LIST_PERMISSION_MISSING,EXPORT_GET_PERMISSION_MISSING,EXPORT_NOT_FOUND` |
| issues       | description [*required*] | string   | Human-readable description of the validation issue.                                                                                                                                                                                                                                                                                                                                 |
| data         | id [*required*]          | string   | AWS CCM config validation resource identifier.                                                                                                                                                                                                                                                                                                                                      |
| data         | type [*required*]        | enum     | AWS CCM config validation resource type. Allowed enum values: `ccm_config_validation`                                                                                                                                                                                                                                                                                               |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "account_id": "123456789012",
      "issues": [
        {
          "code": "EXPORT_NOT_FOUND",
          "description": "no CUR 2.0 export named \"cost-and-usage-report\" found"
        }
      ]
    },
    "id": "ccm_config_validation",
    "type": "ccm_config_validation"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="503" %}
Service Unavailable
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/integration/aws/validate_ccm_config" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "account_id": "123456789012",
      "bucket_name": "billing",
      "bucket_region": "us-east-1",
      "report_name": "cost-and-usage-report",
      "report_prefix": "reports"
    },
    "type": "ccm_config_validation"
  }
}
EOF 
                
{% /tab %}
